export declare class PublicBase {
    protected modified: number;
    protected synced: number;
    protected tags: any[];
    protected notes: any[];
    constructor();
    getLatestModified(): number;
    getLastSynced(): number;
    getNotes(filters?: any[]): any[];
    getTags(): any[];
    protected updateSynced(): void;
    protected updateLatestModified(modified: number): void;
    protected pruneMissingKeywords(staleKeywords: any[]): void;
    protected addTagsToNote(note: any, tags: any[], owner?: string): any;
    protected updateNote(note: any, updateNoteFieldsFn: (oldNote: any, newNote: any) => void): any[];
    protected updateTag(tag: any): any;
    protected getTagByUUID(uuid: string): any;
}
export declare class PublicHeaders extends PublicBase {
    private owners;
    constructor(publicResponse: any);
    updateHeaders(publicResponse: any): void;
    private addOwners(users?, collectives?, commonTags?);
    private addOwner(owner, ownerType);
    private updateNoteFields(oldNote, newNote);
}
export declare class PublicItems extends PublicBase {
    private handle;
    private displayName;
    private ownerType;
    private shortId;
    private format?;
    private content?;
    private blacklisted?;
    private ui?;
    private ownerModified?;
    private ownerProcessed?;
    constructor(handle: string, itemsResponse: any);
    updateItems(itemsResponse: any): void;
    getNote(path: string): any;
    getOwner(): any;
    getShortId(shortId: string): any;
    setOwnerProcessed(data: any): any;
    private addItems(notes?, tags?, collectiveTags?, unpublished?, assignees?);
    private updateNoteFields(oldNote, newNote);
}
export declare function processExternalPublicNote(publicNote: any): any;
