import { PublicHeaders, PublicItems } from "./extendedmind-data";
export interface ClientPlatformInfo {
    url?: string;
    name?: string;
    notes?: string;
    pub_date?: string;
    version: string;
    userType: number;
    updateUrl?: string;
    fullUrl?: string;
}
export interface ClientPlatform {
    "platform": string;
    info: ClientPlatformInfo;
}
export interface Info {
    build: string;
    commonCollective: [string, string];
    version: string;
    created: number;
    ui?: string;
    clients?: ClientPlatform[];
}
export declare class Utils {
    private backendApiUrl;
    defaultCacheSettings: {
        maxCachedHandles: number;
        syncTimeTreshold: number;
    };
    private cacheSettings;
    private handleCache;
    private lastHandleCacheReset;
    private headers;
    private lastHeadersReset;
    constructor(backendApiUrl: string, cacheSettings?: any);
    fetchPublicItems(handle: any): Promise<PublicItems>;
    refreshPublicItems(handle: any, cachedItems: any): Promise<any>;
    fetchPublicHeaders(): Promise<PublicHeaders>;
    refreshPublicHeaders(cachedHeaders: PublicHeaders): Promise<PublicHeaders>;
    getPublicItems(handle: any): Promise<any>;
    getPublicHeaders(): Promise<any>;
    getPreviewItem(ownerUUID: any, itemUUID: any, previewCode: any): Promise<any>;
    getInfo(latest?: boolean, history?: boolean): Promise<Info>;
    getShortId(shortId: any): Promise<any>;
}
